// rclick.cpp : Defines the entry point for the application.
//

#include "stdafx.h"
#include "resource.h"
#include <shlobj.h>

#define MAX_LOADSTRING 100
#define ID_EDIT 100
#define ID_CHECKBOX1 110
#define ID_CHECKBOX2 120
#define ID_CHECKBOX3 130

// Global Variables:
HINSTANCE hInst;								// current instance
TCHAR szTitle[MAX_LOADSTRING];								// The title bar text
TCHAR szWindowClass[MAX_LOADSTRING];								// The title bar text

// Foward declarations of functions included in this code module:
ATOM				MyRegisterClass(HINSTANCE hInstance);
BOOL				InitInstance(HINSTANCE, int);
LRESULT CALLBACK	WndProc(HWND, UINT, WPARAM, LPARAM);
LRESULT CALLBACK	About(HWND, UINT, WPARAM, LPARAM);

LPCONTEXTMENU2 g_lpContextMenu2=NULL;

int APIENTRY WinMain(HINSTANCE hInstance,
                     HINSTANCE hPrevInstance,
                     LPSTR     lpCmdLine,
                     int       nCmdShow)
{
 	// TODO: Place code here.
	MSG msg;
	HACCEL hAccelTable;

	// Initialize global strings
	LoadString(hInstance, IDS_APP_TITLE, szTitle, MAX_LOADSTRING);
	LoadString(hInstance, IDC_RCLICK, szWindowClass, MAX_LOADSTRING);
	MyRegisterClass(hInstance);
	CoInitialize(NULL);

	// Perform application initialization:
	if (!InitInstance (hInstance, nCmdShow)) 
	{
		return FALSE;
	}

	hAccelTable = LoadAccelerators(hInstance, (LPCTSTR)IDC_RCLICK);

	// Main message loop:
	while (GetMessage(&msg, NULL, 0, 0)) 
	{
		if (!TranslateAccelerator(msg.hwnd, hAccelTable, &msg)) 
		{
			TranslateMessage(&msg);
			DispatchMessage(&msg);
		}
	}
	CoUninitialize();

	return msg.wParam;
}

//
//  FUNCTION: MyRegisterClass()
//
//  PURPOSE: Registers the window class.
//
//  COMMENTS:
//
//    This function and its usage is only necessary if you want this code
//    to be compatible with Win32 systems prior to the 'RegisterClassEx'
//    function that was added to Windows 95. It is important to call this function
//    so that the application will get 'well formed' small icons associated
//    with it.
//
ATOM MyRegisterClass(HINSTANCE hInstance)
{
	WNDCLASSEX wcex;

	wcex.cbSize = sizeof(WNDCLASSEX); 

	wcex.style			= CS_HREDRAW | CS_VREDRAW;
	wcex.lpfnWndProc	= (WNDPROC)WndProc;
	wcex.cbClsExtra		= 0;
	wcex.cbWndExtra		= 0;
	wcex.hInstance		= hInstance;
	wcex.hIcon			= LoadIcon(hInstance, (LPCTSTR)IDI_RCLICK);
	wcex.hCursor		= LoadCursor(NULL, IDC_ARROW);
	wcex.hbrBackground	= (HBRUSH)(COLOR_WINDOW+1);
	wcex.lpszMenuName	= (LPCSTR)IDC_RCLICK;
	wcex.lpszClassName	= szWindowClass;
	wcex.hIconSm		= LoadIcon(wcex.hInstance, (LPCTSTR)IDI_SMALL);

	return RegisterClassEx(&wcex);
}

//
//   FUNCTION: InitInstance(HANDLE, int)
//
//   PURPOSE: Saves instance handle and creates main window
//
//   COMMENTS:
//
//        In this function, we save the instance handle in a global variable and
//        create and display the main program window.
//
BOOL InitInstance(HINSTANCE hInstance, int nCmdShow)
{
   HWND hWnd;

   hInst = hInstance; // Store instance handle in our global variable

   hWnd = CreateWindow(szWindowClass, szTitle, WS_OVERLAPPEDWINDOW,
      CW_USEDEFAULT, 0, CW_USEDEFAULT, 0, NULL, NULL, hInstance, NULL);

   if (!hWnd)
   {
      return FALSE;
   }

   SetWindowLong(CreateWindow("EDIT","C:\\WINDOWS\\notepad.exe",WS_CHILD | WS_TABSTOP | WS_VISIBLE | WS_BORDER | ES_AUTOHSCROLL,
      20,20,300,20,hWnd,0,hInst,NULL),GWL_ID,ID_EDIT);

   SetWindowLong(CreateWindow("BUTTON","SetDllDirectory during menu creation",WS_CHILD | WS_TABSTOP | WS_VISIBLE | BS_AUTOCHECKBOX,
      20,45,300,20,hWnd,0,hInst,NULL),GWL_ID,ID_CHECKBOX1);
   SetWindowLong(CreateWindow("BUTTON","SetDllDirectory when launching command",WS_CHILD | WS_TABSTOP | WS_VISIBLE | BS_AUTOCHECKBOX,
      20,70,300,20,hWnd,0,hInst,NULL),GWL_ID,ID_CHECKBOX2);
   SetWindowLong(CreateWindow("BUTTON","SetDllDirectory AFTER launching command",WS_CHILD | WS_TABSTOP | WS_VISIBLE | BS_AUTOCHECKBOX,
      20,95,300,20,hWnd,0,hInst,NULL),GWL_ID,ID_CHECKBOX3);
   CheckDlgButton(hWnd,ID_CHECKBOX1,BST_CHECKED);
   CheckDlgButton(hWnd,ID_CHECKBOX2,BST_CHECKED);
   CheckDlgButton(hWnd,ID_CHECKBOX3,BST_CHECKED);

   ShowWindow(hWnd, nCmdShow);
   UpdateWindow(hWnd);

   return TRUE;
}

void cutlastbackslash(char* thedir)
{
	int l=strlen(thedir);
	if (l && thedir[l-1]=='\\')
		thedir[l-1]=0;
}

void DestroyIDList(LPITEMIDLIST idlist)
{
	IMalloc* pMalloc;
	pMalloc=NULL;
	SHGetMalloc(&pMalloc);
	if (pMalloc)
		pMalloc->Free(idlist);
	pMalloc->Release();
}

typedef BOOL (WINAPI* tSetDllDirectory)(LPCTSTR lpPathName);
tSetDllDirectory SetDllDirectory=NULL;

BOOL SetDlgPathCalled=false;

void showrightclickmenu(HWND hWnd,char* fullpath)
{
	LPSHELLFOLDER DesktopFolder,CurrentDir;
	LPITEMIDLIST idlist;
	LPITEMIDLIST* lpidl;
	LPCONTEXTMENU lpcm;
	HRESULT res;
	HMENU menu;
	POINT pt;
	CMINVOKECOMMANDINFO cmi;
	WCHAR unicodename[MAX_PATH];
	char szTemp[MAX_PATH];
	char* p;
	char ch;
	int j,k;
	BOOL SetDlgPath;

	SetDlgPath=BST_CHECKED==IsDlgButtonChecked(hWnd,ID_CHECKBOX1);
	if (SetDlgPath || SetDlgPathCalled) {
		if (!SetDllDirectory)
			SetDllDirectory=(tSetDllDirectory)GetProcAddress(GetModuleHandle("kernel32"),"SetDllDirectoryA");
		if (SetDllDirectory)
			if (SetDlgPath) {
				SetDllDirectory("");
				SetDlgPathCalled=true;
			} else if (SetDlgPathCalled) {
				SetDllDirectory(NULL);
				SetDlgPathCalled=false;
			}
	}

	res=SHGetDesktopFolder(&DesktopFolder);
	if (!SUCCEEDED(res))
		return;

	cutlastbackslash(fullpath);
	p=strrchr(fullpath,'\\');
	if (!p) {     // drive root?
		strcat(fullpath,"\\");
		MultiByteToWideChar(CP_ACP, 0, fullpath, -1, unicodename, MAX_PATH);
		if (fullpath[1]!=':' || !SUCCEEDED(SHGetSpecialFolderLocation(hWnd,CSIDL_DRIVES,&idlist))) {
			DesktopFolder->Release();
			return;
		}
		res=DesktopFolder->BindToObject(idlist, NULL, IID_IShellFolder,(void**) &CurrentDir);
		DestroyIDList(idlist);
		DesktopFolder->Release();
		if (!SUCCEEDED(res))
			return;
		res=CurrentDir->ParseDisplayName(hWnd,NULL,unicodename,NULL,&idlist,NULL);
		if (!SUCCEEDED(res)) {
			CurrentDir->Release();
			return;
		}
	} else {
		ch=p[1];
		p[1]=0;
		MultiByteToWideChar(CP_ACP, 0, fullpath, -1, unicodename, MAX_PATH);
		p[1]=ch;
		res=DesktopFolder->ParseDisplayName(hWnd,NULL,unicodename,NULL,&idlist,NULL);
		if (!SUCCEEDED(res)) {
			DesktopFolder->Release();
			return;
		}
		res=DesktopFolder->BindToObject(idlist, NULL, IID_IShellFolder,(void**) &CurrentDir);
		DesktopFolder->Release();
		if (!SUCCEEDED(res))
			return;
		MultiByteToWideChar(CP_ACP, 0, p+1, -1, unicodename, MAX_PATH);
		res=CurrentDir->ParseDisplayName(hWnd,NULL,unicodename,NULL,&idlist,NULL);
		if (!SUCCEEDED(res)) {
			CurrentDir->Release();
			return;
		}
	}
	lpidl=&idlist;
	res=CurrentDir->GetUIObjectOf(hWnd, 1,  
        (const struct _ITEMIDLIST **)lpidl, IID_IContextMenu, NULL,(void**) &lpcm);

	DestroyIDList(idlist);
	if (!SUCCEEDED(res)) {
		CurrentDir->Release();
		return;
	}

	lpcm->QueryInterface(IID_IContextMenu2,(void**) &g_lpContextMenu2);


	menu=CreatePopupMenu();
    if (menu) {
		res=lpcm->QueryContextMenu(menu, 0, 100, 0x7fff, CMF_CANRENAME);
		GetCursorPos(&pt);
		if SUCCEEDED(res) {
            j=0;
            do {
              j++;
              k=GetMenuItemID(menu,j);
              if (k>=100) {
                szTemp[0]=0;
                lpcm->GetCommandString(k-100, GCS_VERB, NULL, szTemp, sizeof(szTemp)-1);
                if (strcmp(szTemp,"copy")==0) {
                  InsertMenu(menu,j+1,MF_BYPOSITION | MF_STRING,0x08001,"Pack");
                  j=-1;
				}
			  }
			} while (j>=0 && j<GetMenuItemCount(menu));
			
			res=(int)(TrackPopupMenu(menu,
	            TPM_LEFTALIGN | TPM_RETURNCMD | TPM_RIGHTBUTTON,
		        pt.x, pt.y, 0, hWnd, NULL));
			if (res==0x08001) 
				MessageBox(hWnd,"'Pack' selected!","Test",MB_ICONINFORMATION);
			if (res) {
				memset(&cmi,0,sizeof(cmi));
				cmi.cbSize = sizeof(cmi);
				cmi.hwnd   = hWnd;
				cmi.lpVerb = MAKEINTRESOURCE(res-100);
				cmi.nShow  = SW_SHOWNORMAL;

				SetDlgPath=BST_CHECKED==IsDlgButtonChecked(hWnd,ID_CHECKBOX2);
				if (SetDlgPath || SetDlgPathCalled) {
					if (!SetDllDirectory)
						SetDllDirectory=(tSetDllDirectory)GetProcAddress(GetModuleHandle("kernel32"),"SetDllDirectoryA");
					if (SetDllDirectory)
						if (SetDlgPath) {
							SetDllDirectory("");
							SetDlgPathCalled=true;
						} else if (SetDlgPathCalled) {
							SetDllDirectory(NULL);
							SetDlgPathCalled=false;
						}
				}
				
				res=lpcm->InvokeCommand(&cmi);

				SetDlgPath=BST_CHECKED==IsDlgButtonChecked(hWnd,ID_CHECKBOX3);
				if (SetDlgPath || SetDlgPathCalled) {
					if (!SetDllDirectory)
						SetDllDirectory=(tSetDllDirectory)GetProcAddress(GetModuleHandle("kernel32"),"SetDllDirectoryA");
					if (SetDllDirectory)
						if (SetDlgPath) {
							SetDllDirectory("");
							SetDlgPathCalled=true;
						} else if (SetDlgPathCalled) {
							SetDllDirectory(NULL);
							SetDlgPathCalled=false;
						}
				}
			}
		}
		DestroyMenu(menu);
	}	
	lpcm->Release();
	if (g_lpContextMenu2)
		g_lpContextMenu2->Release();
	g_lpContextMenu2=NULL;

	CurrentDir->Release();
}			

//
//  FUNCTION: WndProc(HWND, unsigned, WORD, LONG)
//
//  PURPOSE:  Processes messages for the main window.
//
//  WM_COMMAND	- process the application menu
//  WM_PAINT	- Paint the main window
//  WM_DESTROY	- post a quit message and return
//
//
LRESULT CALLBACK WndProc(HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam)
{
	int wmId, wmEvent;
	PAINTSTRUCT ps;
	HDC hdc;
	TCHAR szHello[MAX_LOADSTRING];
	char buf[MAX_PATH];
	LoadString(hInst, IDS_HELLO, szHello, MAX_LOADSTRING);

	if (g_lpContextMenu2) {
		switch (message) 
		{
			case WM_INITMENUPOPUP:
				g_lpContextMenu2->HandleMenuMsg(message, wParam, lParam);
				return 0;
			case WM_MEASUREITEM:
			case WM_DRAWITEM:
			case WM_DELETEITEM:
				if (wParam==0) {
					g_lpContextMenu2->HandleMenuMsg(message, wParam, lParam);
					return 1;
				}
		}
	}

	switch (message) 
	{
		case WM_RBUTTONDOWN:
			GetDlgItemText(hWnd,ID_EDIT,buf,sizeof(buf)-1);
			showrightclickmenu(hWnd,buf);
			break;
		case WM_COMMAND:
			wmId    = LOWORD(wParam); 
			wmEvent = HIWORD(wParam); 
			// Parse the menu selections:
			switch (wmId)
			{
				case IDM_ABOUT:
				   DialogBox(hInst, (LPCTSTR)IDD_ABOUTBOX, hWnd, (DLGPROC)About);
				   break;
				case IDM_EXIT:
				   DestroyWindow(hWnd);
				   break;
				default:
				   return DefWindowProc(hWnd, message, wParam, lParam);
			}
			break;
		case WM_PAINT:
			hdc = BeginPaint(hWnd, &ps);
			// TODO: Add any drawing code here...
			RECT rt;
			GetClientRect(hWnd, &rt);
			DrawText(hdc, "Right click to show context menu of the following object:", -1, &rt, DT_CENTER);
			EndPaint(hWnd, &ps);
			break;
		case WM_DESTROY:
			PostQuitMessage(0);
			break;
		default:
			return DefWindowProc(hWnd, message, wParam, lParam);
   }
   return 0;
}

// Mesage handler for about box.
LRESULT CALLBACK About(HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam)
{
	switch (message)
	{
		case WM_INITDIALOG:
				return TRUE;

		case WM_COMMAND:
			if (LOWORD(wParam) == IDOK || LOWORD(wParam) == IDCANCEL) 
			{
				EndDialog(hDlg, LOWORD(wParam));
				return TRUE;
			}
			break;
	}
    return FALSE;
}
